
#ifndef _win32_directsound_sound_mgr_stereo_STEREO_
#define _win32_directsound_sound_mgr_stereo_STEREO_

#include <dsound.h> // directX include

#include "sound_mgr.h"
#include "CSndRec.h"

class win32_directsound_sound_mgr_stereo : public sound_mgr
{
public:
	win32_directsound_sound_mgr_stereo(HWND window_handle, int sample_bits, int sample_rate, int buffer_length_in_frames, int volume);
	~win32_directsound_sound_mgr_stereo();

	void reset();

	// lock down for a period of inactivity
	void freeze();
	void thaw();

	void clear_buffer();

	boolean lock(sound_buf_pos which, void** buf, uint32* buf_len);
	void unlock();

	int get_buffer_len()  { return buffer_len; }

	// returns SOUND_BUF_LOW or SOUND_BUF_HIGH
	sound_buf_pos get_currently_playing_half();

	boolean IsNull() { return FALSE; }

	bool start_sndrec( char *fn, uint32 nSampleBits, uint32 nSampleRate );
	void end_sndrec();
	bool IsRecording();

protected:
	int buffer_len;

	LPDIRECTSOUND       lpDS;           // DirectSound interface pointer
	LPDIRECTSOUNDBUFFER lpDSbPrimary; // the sound buffer
	LPDIRECTSOUNDBUFFER lpDSbSecondary; // the sound buffer
	HWND wnd_handle;

	boolean buffer_locked;
	boolean playing;

	// data for buffer locking/unlocking ///
	void*  temp_buf;
	uint32 temp_buf_len;
	void*  temp_buf2;
	uint32 temp_buf2_len;
	////////////////////////////////////////

	// Class of Recording *.wav file. added by Mikami Kana.
	CSndRec *rec;

private:
};


#endif
