#ifndef _PCE_PAD_H_
#define _PCE_PAD_H_




#define	PCEPAD_LEFT		0x80
#define	PCEPAD_DOWN		0x40
#define	PCEPAD_RIGHT	0x20
#define	PCEPAD_UP		0x10
#define	PCEPAD_START	8
#define	PCEPAD_SELECT	4
#define	PCEPAD_B		2
#define	PCEPAD_A		1


#include "controller.h"

class PCE_pad : public controller
{
	uint16 inp_state;

public:
	PCE_pad()
	{
		inp_state = 0xFFFF;
	}
	~PCE_pad() {}

	void set_button_state(int button, boolean pressed)
	{
		if(pressed)
		{
			inp_state &= ~button;
		}
		else
		{
			inp_state |= button;
		}
	}

	boolean is_pressed(int button)
	{
		return (inp_state & button);
	}

	void release_all_buttons() { inp_state = 0xFFFF; }

	uint16 get_inp_state()
	{
		uint16 temp = inp_state;
/*
		// up and down cancel out
		if((PCEPAD_UP | PCEPAD_DOWN) == (temp & (PCEPAD_UP | PCEPAD_DOWN)))
		{
			temp &= 0xFF - (PCEPAD_UP | PCEPAD_DOWN);
		}

		// left and right cancel out
		if((PCEPAD_LEFT | PCEPAD_RIGHT) == (temp & (PCEPAD_LEFT | PCEPAD_RIGHT)))
		{
			temp &= 0xFF - (PCEPAD_LEFT | PCEPAD_RIGHT);
		}
*/
		return temp;
	}
};

#endif

